// move.js

// dependencies: general.js, dynamic.js

function MoveUp(a)
{
    var strNum = a.name;
    var nNum = parseInt(strNum);
    if (nNum <= 1)
        return;

    var strT = "SpellName" + FormatNumber(nNum - 1);
    var strB = "SpellName" + strNum;
    Swap(strT, strB);
    
    strT = "SpellRef" + FormatNumber(nNum - 1);
    strB = "SpellRef" + strNum;
    Swap(strT, strB);
    
    strT = "SpellSchool" + FormatNumber(nNum - 1);
    strB = "SpellSchool" + strNum;
    Swap(strT, strB);
    
    strT = "SpellLevel" + FormatNumber(nNum - 1);
    strB = "SpellLevel" + strNum;
    Swap(strT, strB);
    
    strT = "SpellTime" + FormatNumber(nNum - 1);
    strB = "SpellTime" + strNum;
    Swap(strT, strB);
    
    strT = "SpellDuration" + FormatNumber(nNum - 1);
    strB = "SpellDuration" + strNum;
    Swap(strT, strB);
    
    strT = "SpellRange" + FormatNumber(nNum - 1);
    strB = "SpellRange" + strNum;
    Swap(strT, strB);
    
    strT = "SpellComponents" + FormatNumber(nNum - 1);
    strB = "SpellComponents" + strNum;
    Swap(strT, strB);
    
    strT = "SpellOther" + FormatNumber(nNum - 1);
    strB = "SpellOther" + strNum;
    Swap(strT, strB);
}

function MoveDown(a)
{
    var nSlots = document.all.NumSlots.value;
    var strNum = a.name;
    var nNum = parseInt(a.name);
    if (nNum >= nSlots)
        return;
    
    var strB = "SpellName" + FormatNumber(nNum + 1);
    var strT = "SpellName" + strNum;
    Swap(strT, strB);
    
    strB = "SpellRef" + FormatNumber(nNum + 1);
    strT = "SpellRef" + strNum;
    Swap(strT, strB);
    
    strB = "SpellSchool" + FormatNumber(nNum + 1);
    strT = "SpellSchool" + strNum;
    Swap(strT, strB);
    
    strB = "SpellLevel" + FormatNumber(nNum + 1);
    strT = "SpellLevel" + strNum;
    Swap(strT, strB);
    
    strB = "SpellTime" + FormatNumber(nNum + 1);
    strT = "SpellTime" + strNum;
    Swap(strT, strB);
    
    strB = "SpellDuration" + FormatNumber(nNum + 1);
    strT = "SpellDuration" + strNum;
    Swap(strT, strB);
    
    strB = "SpellRange" + FormatNumber(nNum + 1);
    strT = "SpellRange" + strNum;
    Swap(strT, strB);
    
    strB = "SpellComponents" + FormatNumber(nNum + 1);
    strT = "SpellComponents" + strNum;
    Swap(strT, strB);
    
    strB = "SpellOther" + FormatNumber(nNum + 1);
    strT = "SpellOther" + strNum;
    Swap(strT, strB);
}

function Swap(to, from)
{
    try {
        var str = document.all[from].value;
        document.all[from].value = document.all[to].value;
        document.all[to].value = str;
        UpdateData(document.all[to]);
        UpdateData(document.all[from]);
    }
    catch (e)
    {
        if (e.description)
        {
            alert("An unhandled error occured. Process aborted.");
            if (__DEBUG__)
                throw e;
        }
        else
            alert("An error occurred: " + e + "\n\nProcess aborted.");
    }
}