// ac.js

// Functions for calculating Armor Class.
// Dependencies general.js

function CalcAC()
{
    // Recalculates the total AC.
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;

    var inAC, myACArmor, myACShield, myACDex, myACSize, myACMisc;
    inAC = document.all.AC;
    myACArmor = document.all.ACArmor.value;
    myACShield = document.all.ACShield.value;
    myACDex = document.all.ACDex.value;
    myACSize = document.all.ACSize.value;
    myACMisc = document.all.ACMisc.value;
    inAC.value = parseInt(Add(10, myACArmor, myACShield, myACDex,
        myACSize, myACMisc));
    
    window.status = "Recalculated AC.";
}

function ChangeArmorAC()
{
    // Modifies the AC if armor is worn
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;

    // Apply to Armor Class.
    var inACArmor, myArmorBonus;
    inACArmor = document.all.ACArmor;
    myArmorBonus = document.all.ArmorBonus.value;
    inACArmor.value = myArmorBonus;

    CalcAC();
}

function ChangeShieldAC()
{
    // Modifies the AC if a shield is equipped
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;

    // Apply to Armor Class.
    var inACShield, myShieldBonus;
    inACShield = document.all.ACShield;
    myShieldBonus = document.all.ShieldBonus.value;
    inACShield.value = myShieldBonus;

    CalcAC();
}
