// gear.js

// Functions for managing the gear area of the character sheet.
// Dependencies: general.js
function RecalcWeight()
{
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;

    // Recalculates the total weight of equipment.
    var nWeight = 0;
    var nNum;
    for (var i = 0; i < 35; i++)
    {
        nNum = parseFloat(document.all["Gear" + FormatNumber(i + 1) + "W"].value);
        if (isNaN(nNum))
            nNum = 0;
        nWeight += nNum;
    }
    document.all.TotalWeight.innerHTML = nWeight;
    window.status = "Recalculated total equipment weight.";
}